'use strict';

var multihashing = require('multihashing');

function Block(data) {
  var _this = this;

  if (!data) {
    throw new Error('Block must be constructed with data');
  }

  if (!(this instanceof Block)) {
    return new Block(data);
  }

  if (data instanceof Buffer) {
    this.data = data;
  } else {
    this.data = new Buffer(data);
  }

  this.key = function (hashFunc) {
    if (!hashFunc) {
      hashFunc = 'sha2-256';
    }

    return multihashing(_this.data, hashFunc);
  };
}

module.exports = Block;